﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using LEADTOOLS_Express_Import;

namespace LEADTOOLS_Express_Import_Manager
{
    public partial class frmSetup : Form
    {
        RegIO RegEdit = new RegIO();
        public frmSetup()
        {
            InitializeComponent();
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            RegEdit.Save("LEAD Technologies","LEADTOOLS Express Import", txtServer.Text, txtDatabase.Text, txtUser.Text, txtPass.Text, txtPath.Text,txtImageStore.Text);
            this.Close();
        }

        private void frmSetup_Load(object sender, EventArgs e)
        {
            RegEdit.Read("LEAD Technologies","LEADTOOLS Express Import");
            txtServer.Text = RegEdit.Server;
            txtDatabase.Text = RegEdit.Database;
            txtPass.Text = RegEdit.Password;
            txtUser.Text = RegEdit.UserName;
            txtPath.Text = RegEdit.FilePath;
            txtImageStore.Text = RegEdit.ImageStore;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            using (FolderBrowserDialog folder = new FolderBrowserDialog())
            {
                if ( folder.ShowDialog() == DialogResult.OK)
                {
                    txtPath.Text = folder.SelectedPath;
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            using (FolderBrowserDialog folder = new FolderBrowserDialog())
            {
                if (folder.ShowDialog() == DialogResult.OK)
                {
                    txtImageStore.Text = folder.SelectedPath;
                }
            }
        }

        private void txtDatabase_DropDown(object sender, EventArgs e)
        {
            using (var con = new SqlConnection("Data Source=" + txtServer.Text + "; User ID=" + txtUser.Text + "; Password=" + txtPass.Text + ";"))
            {
                try
                {
                    txtDatabase.Items.Clear();

                    con.Open();
                    DataTable databases = con.GetSchema("Databases");

                    foreach (DataRow database in databases.Rows)
                    {
                        String databaseName = database.Field<string>("database_name");
                        txtDatabase.Items.Add(databaseName);
                    }
                }
                catch (Exception)
                {
                }
            }
        }
    }
}
