﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using Microsoft.Win32;

namespace LEADTOOLS_Express_Import_Service
{
    class RegIO
    {
        string RegPath;
        RegistryKey RegKey;

        string _server = "";
        string _database = "";
        string _username = "";
        string _password = "";
        string _filePath = "";
        string _imageStore = "";

        public  string Server
        {
            get { return _server; }
        }

        public  string Database
        {
            get { return _database; }
        }

        public  string UserName
        {
            get { return _username; }
        }

        public  string Password
        {
            get { return _password; }
        }
        public  string FilePath
        {
            get { return _filePath; }
        }
        public string ImageStore
        {
            get { return _imageStore; }
        }

        public void Save(string company, string sAppName, string server, string database, string username, string password, string FilePath,string ImageStore)
        {
            try
            {
                if (System.Environment.Is64BitOperatingSystem)
                {
                    RegPath = @"SOFTWARE\Wow6432Node\" + company + @"\" + sAppName;
                    RegKey = Registry.LocalMachine.OpenSubKey(RegPath);

                    if (RegKey == null)
                    {
                        RegKey = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Wow6432Node\",true);
                        RegKey.CreateSubKey(company);
                        RegKey = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Wow6432Node\" + company, true);
                        RegKey.CreateSubKey(sAppName);
                        RegKey = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Wow6432Node\" + company + @"\" + sAppName, true);
                    }
                }
                else
                {
                    RegPath = @"SOFTWARE\" + company + @"\" + sAppName;

                    if (RegKey == null)
                    {
                        RegKey = Registry.LocalMachine.OpenSubKey("SOFTWARE", true);
                        RegKey.CreateSubKey(company);
                        RegKey = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\" + company, true);
                        RegKey.CreateSubKey(sAppName);
                        RegKey = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\" + company + @"\" + sAppName, true);
                    }
                }

                RegKey = Registry.LocalMachine.OpenSubKey(RegPath, true);

                RegKey.SetValue("Server Name", server);
                RegKey.SetValue("Database Name", database);
                RegKey.SetValue("Username", username);
                RegKey.SetValue("Password", password);
                RegKey.SetValue("File Path", FilePath);
                RegKey.SetValue("Image Store", ImageStore);

                RegKey.Close();
            }
            catch (Exception ex)
            {
                EventLog.WriteEntry(sAppName, ex.Message, EventLogEntryType.Information);
            }
        }

        public void Read(string sCompany, string sAppName)
        {
            if (System.Environment.Is64BitOperatingSystem)
            {
                RegPath = @"SOFTWARE\Wow6432Node\" + sCompany + @"\" + sAppName;
            }
            else
            {
                RegPath = @"SOFTWARE\" + sCompany + @"\" + sAppName;
            }

            RegKey = Registry.LocalMachine.OpenSubKey(RegPath);

            if (RegKey != null)
                _server = RegKey.GetValue("Server Name", "").ToString();

            if (RegKey != null)
            _database = RegKey.GetValue("Database Name","").ToString();

            if (RegKey != null)
            _username = RegKey.GetValue("Username", "").ToString();

            if (RegKey != null)
            _password = RegKey.GetValue("Password", "").ToString();

            if (RegKey != null)
            _filePath = RegKey.GetValue("File Path", "").ToString();

            if (RegKey != null)
                _imageStore = RegKey.GetValue("Image Store", "").ToString();

            if(RegKey != null)
                RegKey.Close();
        }
    }
}
