﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.IO;
using System.Timers;
using Leadtools;
using Leadtools.Dicom;

namespace LEADTOOLS_Express_Import_Service
{
   public partial class Service1 : ServiceBase
   {
      public string sAppName = "LEADTOOLS Express Import";
      public string sCompany = "LEAD Technologies";

      private Timer timer1 = null;
      private string sLog = "Application";

      public Service1()
      {
         InitializeComponent();
      }

      protected override void OnStart(string[] args)
      {
         try
         {
            string licenseFilePath = @"C:\LEADTOOLS 19\Common\License\LEADTOOLS.LIC";
            string developerKey = File.ReadAllText(@"C:\LEADTOOLS 19\Common\License\LEADTOOLS.LIC.KEY");
            RasterSupport.SetLicense(licenseFilePath, developerKey);

            if (!EventLog.SourceExists(sAppName))
               EventLog.CreateEventSource(sAppName, sLog);

            DicomEngine.Startup();

            RegIO MyReg = new RegIO();
            MyReg.Read(sCompany, sAppName);

            if (!string.IsNullOrEmpty(MyReg.Server) && !string.IsNullOrEmpty(MyReg.ImageStore) && !string.IsNullOrEmpty(MyReg.Database) && !string.IsNullOrEmpty(MyReg.FilePath) && !string.IsNullOrEmpty(MyReg.UserName))
            {
               timer1 = new Timer();
               this.timer1.Interval = 5000;
               this.timer1.Elapsed += new System.Timers.ElapsedEventHandler(this.timer1_Tick);
               timer1.Enabled = true;
            }
            else
            {
               EventLog.WriteEntry(sAppName, "Settings not configured. Service Aborted!", EventLogEntryType.Warning);
               System.Environment.Exit(3);
            }
         }
         catch (Exception ex)
         {
            EventLog.WriteEntry(sAppName, ex.Message, EventLogEntryType.Information);
         }
      }

      protected override void OnStop()
      {
         timer1.Enabled = false;
         DicomEngine.Shutdown();
         EventLog.WriteEntry(sAppName, "Service has stopped!", EventLogEntryType.Information);
      }

      private void timer1_Tick(object sender, EventArgs e)
      {
         Work.DoWork(sAppName, sCompany);
      }
   }
}
