﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Diagnostics;
using Leadtools;
using Leadtools.Dicom;
using Leadtools.Medical.Storage.DataAccessLayer;

namespace LEADTOOLS_Express_Import_Service
{
    class Work
    {
        public static void DoWork(string sAppName, string sCompany)
        {
            RegIO RegInfo = new RegIO();
           
            RegInfo.Read(sCompany,sAppName);

            string Folder = RegInfo.FilePath;
            string connectionString = "Data Source=" + RegInfo.Server + ";Initial Catalog=" + RegInfo.Database + ";Integrated Security=False;User ID=" + RegInfo.UserName + ";Password=" + RegInfo.Password + ";Pooling=True";

            if (Directory.Exists(Folder))
            {
                foreach (string file in Directory.GetFiles(Folder))
                {
                    string FileDest;
                    string FolderDest = RegInfo.ImageStore;
                    
                    if (FolderDest[FolderDest.Length - 1].ToString() != @"\")
                    {
                        FolderDest = FolderDest + @"\";
                    }

                    try
                    {
                        DicomDataSet ds = new DicomDataSet();
                        ds.Load(file, DicomDataSetLoadFlags.LoadAndClose);
                        string PatientID = ds.GetValue<string>(DicomTag.PatientID, null);
                        ReferencedImages[] images = new ReferencedImages[0];
                        var dataAccess = new StorageSqlDbDataAccessAgent(connectionString);

                        FolderDest = FolderDest + PatientID.Replace(":", "").Replace(";", "").Replace("*", "");
                        FileDest = FolderDest + @"\" + Path.GetFileName(file);

                        dataAccess.StoreDicom(ds, FileDest, "Express_Import", images, true, true, true, true);

                        if (!Directory.Exists(FolderDest))
                            Directory.CreateDirectory(FolderDest);

                        File.Copy(file, FileDest, true);
                        File.Delete(file);
                        
                    }
                    catch (Exception ex)
                    {
                        FolderDest = RegInfo.ImageStore;

                        if (FolderDest[FolderDest.Length - 1].ToString() != @"\")
                        {
                            FolderDest = FolderDest + @"\";
                        }

                        if (!Directory.Exists(FolderDest + @"_ExpressImport\Invalid\"))
                            Directory.CreateDirectory(FolderDest + @"_ExpressImport\Invalid\");

                        FileDest = FolderDest + @"_ExpressImport\Invalid\" + Path.GetFileName(file);

                        File.Copy(file, FileDest, true);
                        File.Delete(file);

                        EventLog.WriteEntry(sAppName, ex.Message + " File moved to " + FileDest, EventLogEntryType.Warning);
                    }
                    }
                }

                foreach (string dir in Directory.GetDirectories(Folder))
                {
                    foreach (string file in Directory.GetFiles(dir))
                    {
                        string FileDest;
                        string FolderDest = RegInfo.ImageStore;

                        if (FolderDest[FolderDest.Length - 1].ToString() != @"\")
                        {
                            FolderDest = FolderDest + @"\";
                        }

                        try
                        {
                            DicomDataSet ds = new DicomDataSet();
                            ds.Load(file, DicomDataSetLoadFlags.LoadAndClose);
                            string PatientID = ds.GetValue<string>(DicomTag.PatientID, null);
                            ReferencedImages[] images = new ReferencedImages[0];
                            var dataAccess = new StorageSqlDbDataAccessAgent(connectionString);

                            FolderDest = FolderDest + PatientID.Replace(":", "").Replace(";", "").Replace("*", "");
                            FileDest = FolderDest + @"\" + Path.GetFileName(file);

                            dataAccess.StoreDicom(ds, FileDest, "Express_Import", images, true, true, true, true);

                            if (!Directory.Exists(FolderDest))
                                Directory.CreateDirectory(FolderDest);

                            File.Copy(file, FileDest, true);
                            File.Delete(file);

                        }
                        catch (Exception ex)
                        {
                            FolderDest = RegInfo.ImageStore;

                            if (FolderDest[FolderDest.Length - 1].ToString() != @"\")
                            {
                                FolderDest = FolderDest + @"\";
                            }

                            if (!Directory.Exists(FolderDest + @"_ExpressImport\Invalid\"))
                                Directory.CreateDirectory(FolderDest + @"_ExpressImport\Invalid\");

                            FileDest = FolderDest + @"_ExpressImport\Invalid\" + Path.GetFileName(file);

                            File.Copy(file, FileDest, true);
                            File.Delete(file);

                            EventLog.WriteEntry(sAppName, ex.Message + " File moved to " + FileDest, EventLogEntryType.Warning);
                        }
                    }
                }

                foreach (string dir in Directory.GetDirectories(Folder))
                {
                    try
                    {
                        Directory.Delete(dir);
                    }
                    catch (Exception)
                    {
                    }
                }
            }
        }
    }
